﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;
using Infragistics.Documents.Word;

namespace WinGridMerageCellExport
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable tab = new DataTable();
            tab.Columns.Add("Column1", typeof(int)).DefaultValue = 1;
            tab.Columns.Add("Column2", typeof(int)).DefaultValue = 2;
            tab.Columns.Add("Column3", typeof(int)).DefaultValue = 3;
            tab.Columns.Add("Column4", typeof(int)).DefaultValue = 4;

            tab.Rows.Add(1,5,3,4); 
            tab.Rows.Add(5,2,3,4); 
            tab.Rows.Add(1,2,5,4);
            tab.Rows.Add(1, 5, 3, 4); 
            ultraGrid1.DataSource = tab;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.MergedCellStyle = Infragistics.Win.UltraWinGrid.MergedCellStyle.Always;

            UltraGridBand b = e.Layout.Bands[0];

        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {

            ExportGrid(ultraGrid1, "FormattedTextInWord.docx");
            Process.Start("FormattedTextInWord.docx");

        }

        private void ultraGridExcelExporter1_BeginExport(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.BeginExportEventArgs e)
        {
            
        }

        private void ultraGridExcelExporter1_HeaderCellExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.HeaderCellExportingEventArgs e)
        {
            e.Cancel = true;
        }

        private void ExportGrid(UltraGrid grid, string docName)
        {
            Infragistics.Documents.Word.WordDocumentWriter docWriter = WordDocumentWriter.Create(docName);
            docWriter.StartDocument();
            List<UltraGridColumn> visibleColumns = grid.DisplayLayout.Bands[0].Columns.Cast<UltraGridColumn>().ToList<UltraGridColumn>().Where(col => col.Hidden == false).ToList<UltraGridColumn>();

            docWriter.StartTable(visibleColumns.Count);
            TableRowProperties trp = TableRowProperties.Create(docWriter); ;
            trp.Height = grid.DisplayLayout.Override.DefaultRowHeight;
            int lastRowIndex = grid.Rows.Count - 1;
            
            Dictionary<string, TableCellProperties> colCells = new Dictionary<string, TableCellProperties>();

            //Header row
            docWriter.StartTableRow(trp);
            foreach (UltraGridColumn col in visibleColumns)
            {
                colCells.Add(col.Key, TableCellProperties.Create(docWriter));
                docWriter.AddTableCell(col.Header.Caption);
            }
            docWriter.EndTableRow();

            //fill table with data
            for(int rowIndex= 0; rowIndex < grid.Rows.Count; rowIndex++)
            {
                docWriter.StartTableRow(trp);
                foreach (UltraGridColumn col in visibleColumns)
                {
                    if (rowIndex > 0)
                    {
                        UltraGridRow currRow = grid.Rows[rowIndex];
                        UltraGridRow prevRow = grid.Rows[rowIndex - 1];
                        if (currRow.Cells[col.Key].IsMergedWith(prevRow.Cells[col.Key]))
                        {
                            if(colCells[col.Key].VerticalMerge == TableCellVerticalMerge.None)
                                colCells[col.Key].VerticalMerge = TableCellVerticalMerge.Start;
                            else
                                colCells[col.Key].VerticalMerge = TableCellVerticalMerge.Continue;
                        }
                        else
                            colCells[col.Key].VerticalMerge = TableCellVerticalMerge.Start;
                    }
                    else
                        colCells[col.Key].VerticalMerge = TableCellVerticalMerge.Start;
                    
                        
                    docWriter.AddTableCell(grid.Rows[rowIndex].Cells[col.Key].Value.ToString(), colCells[col.Key]);
                }
                docWriter.EndTableRow();
            }
            docWriter.EndTable();

            docWriter.Close();

        }

    }
}
